#!/bin/bash

echo "GET USER VARIABLES"
read -p "Title: " TITLE
read -p "Description: " DESC
read -p "Link: " LURL
read -p "Link Desc: " LDESC
read -p "Tag 1: " TAG1
read -p "Tag 2: " TAG2
read -p "Tag 3: " TAG3
read -p "Tag 4: " TAG4
read -p "Tag 5: " TAG5
read -p "Publish Year: " YEAR
read -p "Publish Month: " MONTH
read -p "Publish Day: " DAY

echo "SET GLOBAL VARIABLES"
TNAME="CahlenLee_""$YEAR""$MONTH""$DAY""_""$TITLE"
FNAME=$(echo "$TNAME"  | sed 's/ //g')

echo "PROCESS MP4"
for file in *.mp4; do
  ffmpeg -i $file -c:v libx264 -r 24 -vf scale=640:360 -b:v 333k -c:a aac -ac 1 -b:a 128k -movflags faststart -af "dynaudnorm=f=33:g=65:p=0.66:m=33.3" -n $FNAME.mp4
  rm $file
done

echo "CREATE MP3"
ffmpeg -i $FNAME.mp4 $FNAME.mp3

echo "PROCESS JPG"
for file in *.jpg
do
  jpegoptim -S 96 "$file"
  mv "$file" "${FNAME}.jpg"
done

echo "CREATE DATA FILE"
/bin/cat <<EOM >$FNAME.txt
$TITLE
$DESC
$LURL
$LDESC
$TAG1
$TAG2
$TAG3
$TAG4
$TAG5
EOM

echo "BACKUP LOCALLY"
mkdir jekyll/_site/files/videos/$YEAR
mkdir jekyll/_site/files/videos/$YEAR/$MONTH
mkdir jekyll/_site/files/videos/$YEAR/$MONTH/$FNAME
mv $FNAME.mp4 jekyll/_site/files/videos/$YEAR/$MONTH/$FNAME/$FNAME.mp4
mv $FNAME.mp3 jekyll/_site/files/videos/$YEAR/$MONTH/$FNAME/$FNAME.mp3
mv $FNAME.jpg jekyll/_site/files/videos/$YEAR/$MONTH/$FNAME/$FNAME.jpg
mv $FNAME.txt jekyll/_site/files/videos/$YEAR/$MONTH/$FNAME/$FNAME.txt

echo "DONE"